var $ = jQuery;

$(document).ready(function () {

    var templates = {
        $module: $($.parseHTML(
            '<div class="moduleGroup" style="display:none">' +
            '	<div class="moduleHead">' +
            '		<div class="name">' +
            '			<input type="text" class="inputName moduleName" value="" placeholder="Наименование модуля">' +
            '		</div>' +
            '		<div class="currentControl">0</div>' +
            '		<div class="landmarkControl">0</div>' +
            '		<div class="actions">' +
            '			<div class="deleteModule icon delete"></div>' +
            '			<div class="downModule icon down"></div>' +
            '			<div class="upModule icon up"></div>' +
            '		</div>' +
            '	</div>' +
            '	<div class="submodules"></div>' +
            '	<button class="addSubmodule">Добавить мероприятие</button>' +
            '</div>'
        )),

        newModule: function (moduleID, submoduleID) {
            var elem = templates.$module.clone().data('id', moduleID);
            elem.children('div.submodules').append(templates.newSubmodule(submoduleID));
            return elem;
        },

        $submodule: $($.parseHTML(
            '<div class="submodule">' +
            '	<div class="name">' +
            '		<input type="text" class="inputName submoduleName" value="" placeholder="Наименование мероприятия">' +
            '	</div>' +
            '	<div class="currentControl"><input type="text" class="inputCredit inputCurrentControl" value="0"></div>' +
            '	<div class="landmarkControl"><input type="text" class="inputCredit inputLandmarkControl" value="0"></div>' +
            '	<div class="actions">' +
            '		<div class="deleteSubmodule icon delete"></div>' +
            '		<div class="downSubmodule icon down"></div>' +
            '		<div class="upSubmodule icon up"></div>' +
            '	</div>' +
            '</div>'
        )),

        newSubmodule: function (id) {
            return templates.$submodule.clone().data('id', id);
        },

        confirm: $($.parseHTML(
            '<div class="confirmDeleteDiv">Уверены? ' +
            '	<span class="confirmDeleteModule">Да</span> ' +
            '	<span class="cancel">Нет</span>' +
            '</div>'
        )),

        submoduleConfirm: $($.parseHTML(
            '<div class="confirmDeleteDiv">Уверены? ' +
            '   <span class="confirmDeleteSubmodule">Да</span> ' +
            '   <span class="cancel">Нет</span>' +
            '</div>'
        ))
    };

    $.fn.sum = function (asText) {
        var sum = 0;
        this.each(function () {
            sum += parseInt(0 + asText ? $(this).text() : $(this).val())
        });
        return sum;
    };

    // Подсчет текущего контроля
    function recountCurrentControl($submodules) {
        var maxCredits = $('input.inputCurrentControl', $submodules).sum();
        $submodules.prev().children('div.currentControl').text(maxCredits);
    }

    // Подсчет рубежного контроля
    function recountLandmarkControl($submodules) {
        var maxCredits = $('input.inputLandmarkControl', $submodules).sum();
        $submodules.prev().children('div.landmarkControl').text(maxCredits);
    }


    function changeSubModuleMaxAndControl(submoduleID, newMaxRate, controlType) {
        return $.post(URLdir + 'handler/map/ChangeSubModuleMaxAndControl', {
            'SubmoduleID': submoduleID,
            'MaxRate':     newMaxRate,
            'ControlType': controlType
        }, function (data) {
            if (!data.success)
                EventInspector.error('Ошибка при изменении макс. балла');
        }, 'json')
    }

    // Установить новый max балл
    function setNewRateAndControl($rateInput, oldMaxRate) {
        var $moduleHeads = $('.moduleHead'),
            currentControl = $moduleHeads.children('.currentControl').sum(true),
            landmarkControl = $moduleHeads.children('.landmarkControl').sum(true);

        // Макс. балл соседней ячейки
        var subtract = parseInt(0 + $rateInput.parent().siblings().children(".inputCredit").val()),
            newMaxRate = parseInt(0 + $rateInput.val()),
            isExam = $('div.ExamModule').length > 0,
            maxPossibleSumRate = isExam ? 60 : 100;

        var rateIndicator = currentControl + landmarkControl + newMaxRate - subtract - oldMaxRate;

        if (rateIndicator > maxPossibleSumRate) {
            if (newMaxRate == 0)
                $rateInput.val('0');
            else {
                $rateInput.removeAttr('disabled').val(oldMaxRate);
                return EventInspector.error('Сумма баллов превышает максимум');
            }
        }


        // Меняем max балл
        if (newMaxRate == oldMaxRate) {
            $rateInput.removeAttr('disabled');
        } else {
            var controlType = ($rateInput.parent().attr('class')).indexOf('landmarkControl') >= 0
                ? 'LandmarkControl' : 'CurrentControl';

            var submoduleID = $rateInput.parents('.submodule').data('id');
            changeSubModuleMaxAndControl(submoduleID, newMaxRate, controlType).always(function () {
                $rateInput.removeAttr('disabled');
            });

            // Счетчик баллов
            if (isExam) rateIndicator += 40;
            $('div.rateIndicatorDIV span.rateIndicator').html(rateIndicator);

            if (controlType == 'CurrentControl')
                $rateInput.parent().parent().find('div.landmarkControl').children('input.inputLandmarkControl').val('0');
            if (controlType == 'LandmarkControl')
                $rateInput.parent().parent().find('div.currentControl').children('input.inputCurrentControl').val('0');
        }

        var $submodules = $rateInput.parents('.submodules');
        recountCurrentControl($submodules);
        recountLandmarkControl($submodules);
    }


    function swapElements($lower, $upper, speed) {
        var lowerRoute = $upper.offset().top - $lower.offset().top,
            upperRoute = lowerRoute + $upper.height() - $lower.height();

        $.when(
            $upper.animate({ top: -upperRoute }, speed || 200),
            $lower.animate({ top: lowerRoute }, speed || 200)
        ).done(function () {
            $upper.add($lower).css('top', '0px');
            $lower.insertBefore($upper);
            animating = false;
        });
    }

    // Поменять местами два модуля
    function swapModulesOrder($lower, $upper) {
        $.post(URLdir + 'handler/map/SwapModuleOrder', {
            'ModuleID1': $lower.data('id'),
            'ModuleID2': $upper.data('id')
        }, function (data) {
            if (!data.success)
                return EventInspector.error('Ошибка при изменении порядка модулей');

            swapElements($lower, $upper)
        }, 'json');
    }

    // Поменять местами два мероприятия
    function swapSubmodulesOrder($lower, $upper) {
        $.post(URLdir + 'handler/map/SwapSubmoduleOrder', {
            'SubmoduleID1': $lower.data('id'),
            'SubmoduleID2': $upper.data('id')
        }, function (data) {
            if (!data.success)
                return EventInspector.error('Ошибка при изменении порядка мероприятий');

            swapElements($lower, $upper);
        }, 'json');
    }

//------------------------------------------------------------------

    var $modules = $('.moduleList');

    // Move module up
    $modules.on('click', '.upModule', function () {
        var $current = $(this).parents('.moduleGroup'),
            $upper = $current.prev('.moduleGroup');

        $upper.length ? swapModulesOrder($current, $upper) : EventInspector.error('Переместить выше нельзя');
    });

    // Move module down
    $modules.on('click', '.downModule', function () {
        var $current = $(this).parents('.moduleGroup'),
            $lower = $current.next('.moduleGroup');

        $lower.length ? swapModulesOrder($lower, $current) : EventInspector.error('Переместить ниже нельзя');
    });

    // Move submodule up
    $modules.on('click', '.upSubmodule', function () {
        var $current = $(this).parents('.submodule'),
            $upper = $current.prev('.submodule');

        $upper.length ? swapSubmodulesOrder($current, $upper) : EventInspector.error('Переместить выше нельзя');
    });

    // Move submodule down
    $modules.on('click', '.downSubmodule', function () {
        var $current = $(this).parents('.submodule'),
            $lower = $current.next('.submodule');

        $lower.length ? swapSubmodulesOrder($lower, $current) : EventInspector.error('Переместить ниже нельзя');
    });


    // Add new module
    $('.addModule').click(function () {
        var $addModuleButton = $(this).attr("disabled", true);

        $.post(URLdir + 'handler/map/AddModule', {
            'DisciplineID': g_disciplineID
        }, function (data) {
            if (!data.success)
                return EventInspector.error('Ошибка при добавлении модуля');

            var $place = $('.moduleList').children('.moduleGroup').last(),
                $module = templates.newModule(data.moduleID, data.submoduleID);

            $place.length > 0 ? $place.after($module) : $('.moduleList').prepend($module);
            $module.slideDown(200);

        }, 'json').always(function () {
            $addModuleButton.removeAttr('disabled')
        });

        // Заглушка "модули отсутствуют"
        $('.empty').remove();
    });

    // Add new submodule
    $modules.on('click', 'button.addSubmodule', function () {
        var $addSubButton = $(this).attr("disabled", true),
            moduleID = $addSubButton.parent('.moduleGroup').data('id');

        $.post(URLdir + 'handler/map/AddSubmodule', {
            'submoduleID': moduleID
        }, function (data) {
            if (!data.success)
                return EventInspector.error('Ошибка при добавлении мероприятия');

            var $submodule = templates.newSubmodule(data.submoduleID);
            $addSubButton.siblings('.submodules').append($submodule);
            $submodule.slideDown(200);

        }, 'json').always(function () {
            $addSubButton.removeAttr('disabled');
        })
    });


    // Удалить модуль
    $modules.on('click', '.deleteModule', function () {
        $(this).parent().hide();
        $(this).parent().parent().append(templates.confirm.clone());
    });

    // Удалить мероприятие
    $modules.on('click', '.deleteSubmodule ', function () {
        $(this).parent().hide();
        $(this).parent().parent().append(templates.submoduleConfirm.clone());
    });


    // Подтверждение при удалении модуля
    $modules.on('click', '.confirmDeleteModule', function () {
        var $modules = $('.moduleGroup'),
            $module = $(this).parents('.moduleGroup');

        $.post(URLdir + 'handler/map/DeleteModule', {
            'ModuleID': $module.data('id')
        }, function (data) {
            if (!data.success)
                return EventInspector.error('Ошибка при удаление модуля');

            $module.slideUp(200, function () {
                $(this).remove();
            });

            var $modulesHead = $modules.children('.moduleHead'),
                currentCtrl = $modulesHead.children('.currentControl').sum(true),
                landmarkCtrl = $modulesHead.children('.landmarkControl').sum(true);

            var exam = $('div.ExamModule').length ? 40 : 0;
            $('span.rateIndicator').html(currentCtrl + landmarkCtrl + exam);

            if ($('.moduleGroup').length == 0)
                $('.moduleList').prepend('<div class="empty"><p class="notification">Модули отсутствуют</p></div>');
        }, 'json');
    });

    // Подтверждение при удалении мероприятия
    $modules.on('click', '.confirmDeleteSubmodule ', function () {
        var $confirmButton = $(this),
            $submodule = $confirmButton.parents('.submodule');

        if ($submodule.siblings('.submodule').andSelf().size() <= 1)
            return EventInspector.error('Невозможно удалить единственное мероприятие в модуле.');

        recountCurrentControl($submodule.parent());
        recountLandmarkControl($submodule.parent());

        $.post(URLdir + 'handler/map/DeleteSubmodule', {
            'SubmoduleID': $submodule.data('id')
        }, function (data) {
            if (!data.success)
                return EventInspector.error('Ошибка при удалении мероприятия');

            var difC = parseInt($submodule.find('div.currentControl').find('input').val()),
                difL = parseInt($submodule.find('div.landmarkControl').find('input').val());

            var $moduleHead = $submodule.parents('.moduleGroup').find('.moduleHead'),
                oldC = parseInt($moduleHead.find('div.currentControl').html()),
                oldL = parseInt($moduleHead.find('div.landmarkControl').html());

            // change module header
            $moduleHead.children('div.currentControl').html(oldC - difC);
            $moduleHead.children('div.landmarkControl').html(oldL - difL);

            // change sum rate
            var rateIndicator = $('span.rateIndicator'),
                old = +rateIndicator.html();
            rateIndicator.html(old - difC - difL);

            $submodule.slideUp(200, function () {
                $(this).remove();
            });
        }, 'json');
    });

    // Отмена удаления модулей/мероприятий
    $modules.on('click', '.cancel ', function () {
        $(this).parent().parent().children('div.actions').show();
        $(this).parent().remove();
    });


    // Поменять название модуля
    var moduleName;
    $modules.on('focusin', 'input.moduleName', function () {
        moduleName = $(this).val(); // todo: $(..).data('lastName', val())
    });

    $modules.on('focusout', 'input.moduleName', function () {
        var $nameInput = $(this).attr("disabled", true);

        var newName = $(this).val();
        if (newName === '' || newName === moduleName)
            return $nameInput.removeAttr('disabled');

        $.post(URLdir + 'handler/map/ChangeModuleName', {
            'ModuleID':   $(this).parents('.moduleGroup').data('id'),
            'ModuleName': newName
        }, function (data) {
            if (!data.success)
                EventInspector.error('Ошибка при изменении имени модуля');
        }, 'json').always(function () {
            $nameInput.removeAttr('disabled');
        });
    });

    $('input.moduleName').keypress(function (e) {
        if (e.charCode == 13)
            $(this).trigger('focusout');
    });


    // Поменять название мероприятие
    var submoduleName;
    $modules.on('focusin', 'input.submoduleName', function () {
        submoduleName = $(this).val();
    });

    $modules.on('focusout', 'input.submoduleName', function () {
        var $nameInput = $(this).attr("disabled", true);

        var newName = $(this).val();
        if (newName === '' || newName === submoduleName)
            return $nameInput.removeAttr('disabled');

        $.post(URLdir + 'handler/map/ChangeSubmoduleName', {
            'SubmoduleID':   $(this).parent('div').parent('div').data('id'),
            'SubmoduleName': newName
        }, function (data) {
            if (!data.success)
                EventInspector.error('Ошибка при изменении имени мероприятия');
        }, 'json').always(function () {
            $nameInput.removeAttr('disabled');
        });
    });

    $modules.on('keydown', 'input.submoduleName', function (e) {
        if (e.keyCode == 13)
            $(this).trigger('focusout');
    });


    // При записи в input текущий контроль
    // При фокусе
    var oldMaxRate = 0;
    $modules.on('focusin', 'input.inputCurrentControl', function () {
        oldMaxRate = $(this).val();
        $(this).select();
    });


    $modules.on('focusout', 'input.inputCurrentControl', function () {
        $(this).attr("disabled", true);
        setNewRateAndControl($(this), oldMaxRate);
    });

    $modules.on('focusin', 'input.inputLandmarkControl', function () {
        oldMaxRate = $(this).val();
        $(this).select();
    });

    $modules.on('focusout', 'input.inputLandmarkControl', function () {
        $(this).attr("disabled", true);
        setNewRateAndControl($(this), oldMaxRate);
    });

    // В inputCredit (где баллы вводить) разрешаем вводить только цифры
    $modules.on('keydown', 'input.inputCredit', function (event) {
        KeyDownOnlyNumber(event);
    });
});
