var $ = jQuery;
var inspectorCounter = 0;
var inspectorMax = 10;
var inspectorList;

$(function () {
    $('body').append('<div class="EventInspectorList"></div>');
    inspectorList = $('div.EventInspectorList');
    inspectorList.on('click', 'div.EventItem', _ => $(this).remove());

    $(window).scroll(function () {
        let size = $(this).scrollTop() > 40 ? '20px' : '50px';
        inspectorList.css('top', size);
    });

});

var EventInspector = {
    show: function (text, type) {
        if (inspectorCounter >= inspectorMax)
            inspectorList.children().first().remove();

        ++inspectorCounter;

        var MsgDiv = inspectorList.append(`<div class="EventItem ${type}">${text}</div>`).children().last();

        let hideMsg = () => MsgDiv.animate({ opacity: 0 }, 1000, _ => MsgDiv.remove());

        setTimeout(() => { --inspectorCounter, hideMsg() }, 4000);
    },

    error: function (text) {
        this.show(text, 'error');
    },

    success: function (text) {
        this.show(text, 'success');
    }
}, Popup = EventInspector;
